jjb: Correct unbound variable usage error
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
447eaf93
KS
21platforms=${platforms:-}
22# Derive arch from label if it isn't set
23if [ -z "${arch:-}" ] ; then
24 # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
25 regex='[[:alnum:]]+-([[:alnum:]]+)'
26 if [[ "${platforms}" =~ ${regex} ]] ; then
27 arch="${BASH_REMATCH[1]}"
28 else
29 arch="${platforms:-}"
30 fi
31fi
39961776
MJ
32cross_arch=${cross_arch:-}
33ktag=${ktag:-}
5a196804
MJ
34kgitrepo=${kgitrepo:-}
35mversion=${mversion:-}
36mgitrepo=${mgitrepo:-}
39961776 37
339db64d
MJ
38## FUNCTIONS ##
39
f3d8604b
MJ
40# Kernel version compare functions
41verlte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
43}
44
45verlt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
48}
49
50vergte() {
51fa2ab3 51 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
52}
53
54vergt() {
28b10e79 55 # shellcheck disable=SC2015
51fa2ab3 56 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
57}
58
339db64d 59
5a196804
MJ
60git_clone_modules_sources() {
61 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
62
63 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
64 # as a branch name.
65 if [ "${mversion:0:5}" = "refs/" ]; then
66 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
67 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
68 else
69 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
70 fi
5a196804
MJ
71}
72
73# Checkout a shallow kernel tree of the specified tag
74git_clone_linux_sources() {
75 mkdir -p "$LINUX_GIT_DIR"
76 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
77}
7e02032c 78
7e02032c 79
5a196804
MJ
80# Export the kernel sources from the git repo
81git_export_linux_sources() {
82 cd "$LINUX_GIT_DIR"
83 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
84}
85
86
87# Upload the tar archive to the object store
88upload_archive_obj() {
89 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
90 rm -f "$WORKSPACE/$obj_name"
91}
92
93
94extract_archive_obj() {
95 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
96 rm -f "$WORKSPACE/$obj_name"
97}
98
99
100tar_archive_obj() {
101 cd "$LINUX_OBJ_DIR"
102 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
103 cd -
104}
105
6c0b2710
KS
106list_gccs() {
107 local gccs
108 gccs=()
109 IFS=: read -r -a path_array <<< "$PATH"
110 while read -r gcc ; do
111 gccs+=("$gcc")
112 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
113 echo "${gccs[@]}"
114}
115
5a196804
MJ
116# Find the most recent GCC version supported by the kernel sources
117select_compiler() {
118 local selected_cc
119
120 cd "$LINUX_SRCOBJ_DIR"
121
122 kversion=$(make -s kernelversion)
123
124 set +e
125
6c0b2710 126 for cc in $(list_gccs) ; do
5a196804
MJ
127 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
128 selected_cc="$cc"
129 break
130 fi
131 done
132
133 set -e
134
135 if [ "x$selected_cc" = "x" ]; then
136 echo "Found no suitable compiler."
137 exit 1
138 fi
139
1d5a0a3c
MJ
140 # Force gcc-4.8 for kernels before 3.18
141 if { verlt "$kversion" "3.18"; }; then
23db2292 142 selected_cc=gcc-4.8
7e02032c
MJ
143 fi
144
425e4992
MJ
145 if [ "$selected_cc" != "gcc-4.8" ]; then
146 # Older kernel Makefiles do not expect the compiler to default to PIE
147 KAFLAGS="-fno-pie"
c45b04df 148 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
149 KCPPFLAGS="-fno-pie"
150 export KAFLAGS KCFLAGS KCPPFLAGS
151 fi
152
5a196804 153 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 154 export HOSTCC="${selected_cc}"
5a196804
MJ
155
156 cd -
157}
158
159
160build_linux_kernel() {
161 cd "$LINUX_SRCOBJ_DIR"
162
163 kversion=$(make -s kernelversion)
164
7e02032c 165 # Generate kernel configuration
a1ae361e 166 case "$ktag" in
7e02032c 167 Ubuntu*)
39961776 168 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 169 if vergte "${kversion}" "4.10"; then
39961776
MJ
170 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
171 exit 0
172 fi
173 fi
af101606
MJ
174
175 # Disable riscv64 config generation, we don't have a toolchain on bionic
176 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
177
0c1bde3d
KS
178 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
179
073dc82c 180 # Hack for kernel Ubuntu-hwe-5.8
0c1bde3d
KS
181 # The debian/control file is produced by the clean target above, so this
182 # check needs to happen afterwards.
183 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
073dc82c
MJ
184 echo "10" > "debian/compat"
185 fi
186
0c1bde3d
KS
187 # genconfigs check can fail in certain cases, eg. when a more recent
188 # compiler exposes kernel configuration flags which aren't set in the
189 # Ubuntu annotations.
190 # In any case, the configuration will be updated with any missing values
191 # later in our build script.
192 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
5a196804 193 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 194 ;;
c45b04df 195
7e02032c 196 *)
16844a6d
MJ
197 # Force 32bit build on i386, default is 64bit
198 if [ "$arch" = "i386" ]; then
5a196804
MJ
199 export ARCH="i386"
200 fi
201
202 # allyesconfig is mostly broken for kernels of the 2.6 series
203 if verlt "$kversion" "3.0"; then
204 vanilla_config="defconfig"
7a76a4d0
MJ
205 fi
206
5a196804 207 make "${vanilla_config}"
7e02032c
MJ
208 ;;
209 esac
210
53b51a15 211 # oldnoconfig was renamed in 4.19
5a196804 212 if vergte "$kversion" "4.19"; then
53b51a15 213 update_conf_target="olddefconfig"
5a196804 214 else
53b51a15 215 update_conf_target="oldnoconfig"
5a196804
MJ
216 fi
217
218 # Fix 'defined(@array)' was removed from recent perl
219 if [ -f "kernel/timeconst.pl" ]; then
220 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
221 fi
222
223 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 224 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
225 if [ -f "arch/x86/kvm/svm.c" ]; then
226 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
227 fi
228
229 if [ -f "arch/x86/kvm/vmx.c" ]; then
230 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
231 fi
232 fi
233
53b51a15
MJ
234 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
235 # Convert them to 'cmpw' which was previously done silently
236 if verlt "$kversion" "4.9"; then
237 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
238 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
239 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
240 fi
241
5a196804
MJ
242 # Fix a typo in v2.6.36.x
243 if [ -f "arch/x86/kernel/entry_64.S" ]; then
244 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
245 fi
246
53b51a15
MJ
247 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
248 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
249 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
250 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
251 fi
252
5a196804
MJ
253 # Fix kernel < 3.0 with gcc >= 4.7
254 if verlt "$kversion" "3.0"; then
255 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
256 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
257 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
258 echo "header-y += linkage.h" >> include/linux/Kbuild
259 fi
260
7e02032c 261 # GCC 4.8
53b51a15
MJ
262 if [ "$HOSTCC" == "gcc-4.8" ]; then
263 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
264 fi
7e02032c
MJ
265
266 # Don't try to sign modules
53b51a15 267 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 268
9ef18fa2 269 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 270 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
271
272 # Cause problems with inline assembly on i386
53b51a15 273 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 274
1d5a0a3c 275 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
276 scripts/config --disable CONFIG_SAMPLES
277 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
278
279 # Disable kcov
53b51a15 280 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
281
282 # Broken on some RT kernels
53b51a15 283 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 284
1e300ea9 285 # Broken drivers
53b51a15
MJ
286 scripts/config --disable CONFIG_RAPIDIO_TSI721
287 scripts/config --disable CONFIG_SGI_XP
288 scripts/config --disable CONFIG_MFD_WM8994
289 scripts/config --disable CONFIG_DRM_RADEON
290 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 291
5a196804
MJ
292 # IGBVF won't build with recent gcc on 2.6.38.x
293 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 294 scripts/config --disable CONFIG_IGBVF
5a196804 295 fi
9ef18fa2 296
c72041eb
MJ
297 # Don't fail the build on warnings
298 scripts/config --disable CONFIG_WERROR
299
51fa2ab3 300 # Set required options
53b51a15
MJ
301 scripts/config --enable CONFIG_TRACEPOINTS
302 scripts/config --enable CONFIG_KALLSYMS
303 scripts/config --enable CONFIG_HIGH_RES_TIMERS
304 scripts/config --enable CONFIG_KPROBES
305 scripts/config --enable CONFIG_FTRACE
306 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
307 scripts/config --enable CONFIG_KALLSYMS_ALL
308 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
309 scripts/config --enable CONFIG_PERF_EVENTS
310 scripts/config --enable CONFIG_EVENT_TRACING
311 scripts/config --enable CONFIG_KRETPROBES
7e02032c 312
1d28ffce
MJ
313 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
314 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
81e61c58
MJ
315 # Starting with v6.1-rc6
316 sed -i 's/^objtool-enabled := .*/objtool-enabled := /' scripts/Makefile.vmlinux_o || true
1d28ffce 317
ba1a68bc
MJ
318 # Disable SORTTAB
319 sed -i 's/is_enabled CONFIG_BUILDTIME_TABLE_SORT/is_enabled CONFIG_NONEXISTANT/' scripts/link-vmlinux.sh || true
320
7a76a4d0 321 # Debug
5a196804
MJ
322 #cat .config
323
324 make "$update_conf_target" CC="$CC"
325 make -j"$NPROC" CC="$CC"
326
c45b04df 327 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
328
329 # Save the kernel and modules
330 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 331 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 332 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
333 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
334 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
335 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
336}
337
338
339extract_distro_headers() {
340
341 # Enter linux source dir
342 cd "${LINUX_SRCOBJ_DIR}"
343
344
345 # For RT kernels, copy version file
346 if [ -s localversion-rt ]; then
347 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
348 fi
349
350 # Copy all Makefile related stuff
351 find . -path './include/*' -prune \
352 -o -path './scripts/*' -prune -o -type f \
353 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
354 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
355 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
356
357 # Copy base scripts and include dirs
358 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 359
5a196804
MJ
360 # Copy arch includes
361 (find arch -name include -type d -print0 | \
362 xargs -0 -n1 -i: find : -type f) | \
363 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
364
365 # Copy arch scripts
366 (find arch -name scripts -type d -print0 | \
367 xargs -0 -n1 -i: find : -type f) | \
368 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
369
370 # Cleanup scripts
371 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
372 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
373
04873cc3 374 # On powerpc 32bits this object is required to link modules
5a196804 375 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
376 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
377 :
378 else
04873cc3
MJ
379 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
380 fi
5a196804
MJ
381 fi
382
383 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
384 if [ "${karch}" = "arm64" ]; then
385 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
386 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
387 fi
388 fi
389
390 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
391 if [ -f tools/objtool/objtool ]; then
392 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
393 fi
394
395 if [ -f "arch/x86/kernel/macros.s" ]; then
396 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
397 fi
398
399 # Copy modules related stuff, if available
400 if [ -s Module.symvers ]; then
401 cp Module.symvers "${LINUX_HDROBJ_DIR}"
402 fi
403
404 if [ -s System.map ]; then
405 cp System.map "${LINUX_HDROBJ_DIR}"
406 fi
407
408 if [ -s Module.markers ]; then
409 cp Module.markers "${LINUX_HDROBJ_DIR}"
410 fi
411
412 # Copy config file
413 cp .config "${LINUX_HDROBJ_DIR}"
414
415 # Make sure the Makefile and version.h have a matching timestamp so that
416 # external modules can be built
417 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
418 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
419 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
420 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
421 else
422 echo "Missing version.h"
423 exit 1
424 fi
425 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
426
427 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
428 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
429 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
430 fi
5a196804
MJ
431
432 # Finally clean the object files from the full source tree
433 make clean
434
435 # And regen the modules support files
436 make modules_prepare CC="$CC"
51fa2ab3 437
04873cc3 438 # On powerpc 32bits this object is required to link modules
d815b018 439 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
440 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
441 :
442 else
04873cc3
MJ
443 make arch/powerpc/lib/crtsavres.o CC="$CC"
444 fi
d815b018
MJ
445 fi
446
7a76a4d0 447 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 448 if [ "${karch}" = "arm64" ]; then
c236528e 449 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 450 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
451 fi
452 fi
453
7e02032c 454 # Version specific tasks
a1ae361e 455 case "$ktag" in
7e02032c
MJ
456 Ubuntu*)
457 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 458 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
459 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
460 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
461 ;;
462 esac
7e02032c
MJ
463}
464
465
339db64d
MJ
466build_modules() {
467
5a196804
MJ
468 local kdir="$1"
469 local outdir="$2"
470 local kversion
471
472 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 473
2456f978
MJ
474 # Try to catch some compatibility problems by turning some
475 # warnings into errors.
999a2aa0 476 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 477
339db64d 478 # Enter lttng-modules source dir
5a196804 479 cd "${MODULES_GIT_DIR}"
339db64d
MJ
480
481 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
482 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
483 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
484 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
485
486 set +e
487
488 # Build modules
51fa2ab3 489 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 490 ret=$?
339db64d 491
5a196804
MJ
492 set -e
493
339db64d 494 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 495 if [ "$ret" -eq 0 ]; then
e9b44189 496 echo "This build should have failed."
339db64d
MJ
497 exit 1
498 fi
499
500 # We have to publish at least one file or the build will fail
5a196804 501 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 502
5a196804 503 KERNELDIR="${kdir}" make clean
7e02032c 504
339db64d
MJ
505 else # Regular build
506
507 # Build modules against full kernel sources
51fa2ab3 508 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
509
510 # Install modules to build dir
5a196804 511 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
512
513 # Clean build dir
5a196804 514 KERNELDIR="${kdir}" make clean
339db64d
MJ
515 fi
516}
517
518
519## MAIN ##
520
f3d8604b
MJ
521# Use all CPU cores
522NPROC=$(nproc)
523
5a196804
MJ
524MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
525LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 526
5a196804
MJ
527LINUX_OBJ_DIR="${WORKSPACE}/linux"
528LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
529LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
530LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 531
5a196804
MJ
532MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
533MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 534
5a196804
MJ
535LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
536
537OBJ_STORE_URL="s3://jenkins"
538
539cd "$WORKSPACE"
540
541# Create build directories
542mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
543
544git_clone_modules_sources
339db64d 545
7e02032c 546# Setup cross compile env if available
39961776 547if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
548
549 case "$cross_arch" in
550 "armhf")
551 karch="arm"
552 cross_compile="arm-linux-gnueabihf-"
53b51a15 553 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
554 ubuntu_config="armhf-config.flavour.generic"
555 ;;
556
557 "arm64")
558 karch="arm64"
559 cross_compile="aarch64-linux-gnu-"
53b51a15 560 vanilla_config="defconfig"
7e02032c
MJ
561 ubuntu_config="arm64-config.flavour.generic"
562 ;;
563
564 "powerpc")
565 karch="powerpc"
566 cross_compile="powerpc-linux-gnu-"
e9b44189 567 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
568 ubuntu_config="powerpc-config.flavour.powerpc-smp"
569 ;;
570
571 "ppc64el")
572 karch="powerpc"
573 cross_compile="powerpc64le-linux-gnu-"
e9b44189 574 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
575 ubuntu_config="ppc64el-config.flavour.generic"
576 ;;
577
578 *)
51fa2ab3 579 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
580 exit 1
581 ;;
582 esac
339db64d 583
7e02032c
MJ
584 # Export variables used by Kbuild for cross compilation
585 export ARCH="${karch}"
586 export CROSS_COMPILE="${cross_compile}"
339db64d 587
7e02032c 588# Set arch specific values if we are not cross compiling
39961776 589elif [ "x${arch}" != "x" ]; then
e9b44189 590
7e02032c 591 case "$arch" in
16844a6d 592 "i386")
7e02032c 593 karch="x86"
e9b44189 594 vanilla_config="allyesconfig"
7e02032c
MJ
595 ubuntu_config="i386-config.flavour.generic"
596 ;;
597
16844a6d 598 "amd64")
7e02032c 599 karch="x86"
e9b44189 600 vanilla_config="allyesconfig"
7e02032c
MJ
601 ubuntu_config="amd64-config.flavour.generic"
602 ;;
603
604 "armhf")
605 karch="arm"
e9b44189 606 vanilla_config="allyesconfig"
7e02032c
MJ
607 ubuntu_config="armhf-config.flavour.generic"
608 ;;
609
610 "arm64")
611 karch="arm64"
e9b44189 612 vanilla_config="allyesconfig"
7e02032c
MJ
613 ubuntu_config="arm64-config.flavour.generic"
614 ;;
615
616 "powerpc")
617 karch="powerpc"
e9b44189 618 vanilla_config="allyesconfig"
7e02032c
MJ
619 ubuntu_config="powerpc-config.flavour.powerpc-smp"
620 ;;
621
622 "ppc64el")
623 karch="powerpc"
e9b44189 624 vanilla_config="allyesconfig"
7e02032c
MJ
625 ubuntu_config="ppc64el-config.flavour.generic"
626 ;;
627
628 *)
629 echo "Unsupported arch $arch"
630 exit 1
631 ;;
632 esac
633else
04873cc3 634 echo "No arch or cross_arch specified"
7e02032c
MJ
635 exit 1
636fi
339db64d 637
339db64d 638
b214d997 639
5a196804
MJ
640# First get the kernel build from the object store, or build it, if it's
641# not available.
339db64d 642
5a196804
MJ
643echo "# Setup endpoint
644host_base = obj.internal.efficios.com
645host_bucket = obj.internal.efficios.com
646bucket_location = us-east-1
647use_https = True
7e02032c 648
5a196804
MJ
649# Setup access keys
650access_key = jenkins
651secret_key = echo123456
339db64d 652
5a196804
MJ
653# Enable S3 v4 signature APIs
654signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 655
c45b04df 656url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 657obj_name="linux.tar.bz2"
87445931
MJ
658
659if [ "x${cross_arch}" = "x" ]; then
909c5352 660 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
87445931 661else
909c5352 662 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
87445931
MJ
663fi
664
5a196804 665obj_url="$obj_url_prefix/$obj_name"
339db64d 666
5a196804 667set +e
e18b6e95
KS
668# In s3cmd 2.3, the return code of get when an object does not exist (64)
669# is different than in 2.2 (12). The return codes of 's3cmd info' are
670# consistent between 2.2 and 2.3.
671s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
5a196804
MJ
672ret=$?
673set -e
339db64d 674
5a196804
MJ
675case "$ret" in
676 "0")
e18b6e95 677 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
5a196804
MJ
678 extract_archive_obj
679 ;;
a1ae361e 680
5a196804
MJ
681 "12")
682 echo "File not found"
339db64d 683
5a196804
MJ
684 # Build all the things and upload
685 # then finish the module build...
339db64d 686
5a196804
MJ
687 git_clone_linux_sources
688 git_export_linux_sources
339db64d 689
5a196804 690 select_compiler
a1ae361e 691
5a196804
MJ
692 ## PREPARE FULL LINUX SOURCE TREE
693 build_linux_kernel
d138fc44 694
5a196804
MJ
695 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
696 extract_distro_headers
339db64d 697
5a196804 698 tar_archive_obj
339db64d 699
5a196804 700 upload_archive_obj
339db64d 701
5a196804 702 ;;
339db64d 703
5a196804
MJ
704 *)
705 echo "Unknown error? Abort"
706 exit 1
707 ;;
708esac
339db64d 709
5a196804 710select_compiler
f3d8604b 711
7e02032c 712## BUILD modules
5a196804
MJ
713# Either we downloaded a pre-build kernel or we built it and uploaded
714# the archive for future builds.
715
716cd "$WORKSPACE"
f3d8604b 717
339db64d 718# Build modules against full kernel sources
5a196804 719build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 720
339db64d 721# Build modules against kernel headers
5a196804 722build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 723
5a196804
MJ
724# Make sure some modules were actually built
725tree "${MODULES_OUTPUT_KSRC_DIR}"
726if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
727 echo "No modules built!"
728 exit 1
729fi
730
5a196804
MJ
731tree "${MODULES_OUTPUT_KHDR_DIR}"
732if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
733 echo "No modules built!"
734 exit 1
735fi
b214d997 736
f3d8604b 737# EOF
This page took 0.064572 seconds and 4 git commands to generate.